## TypeScript FP Compose

[![Typescript FP](https://avatars0.githubusercontent.com/u/52818784?s=100)](https://github.com/typescript-fp)

Curried compose functions with generic types

- [API](API.md)
- [Wiki](https://github.com/typescript-fp/compose/wiki)
- [License](LICENSE.md)

### Usage

#### Requirements
- Typescript 3 
- ES6

#### Install
```
npm install @typescript-fp/compose
```

#### Example
```
import {composeFgGab as compose} from "@typescript-fp/compose"

const add = (a: number) => (b: number) => a + b;
const increment = add(1);
const composedFn = compose(increment)(add);

composedFn(5)(5)
```

### Development

#### Requirements
- Node.js
- Typescript 3

#### Compile
```
npm run build
```

#### Tests
```
npm run test
```
