"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const composeFgGacb_1 = require("../composeFgGacb");
const utilities_1 = require("./utilities");
describe("Partial Application", () => {
    test("Arity", () => {
        expect(composeFgGacb_1.composeFgGacb.length).toStrictEqual(1);
        expect(composeFgGacb_1.composeFgGacb(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgGacb_1.composeFgGacb(utilities_1.fn1)(utilities_1.fn3).length).toStrictEqual(1);
        expect(composeFgGacb_1.composeFgGacb(utilities_1.fn1)(utilities_1.fn3)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgGacb_1.composeFgGacb(utilities_1.fn1)(utilities_1.fn3)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
        expect(composeFgGacb_1.composeFgGacb(utilities_1.fn1)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c).length).toStrictEqual(1);
    });
});
describe("Referential Transparency", () => {
    test("Extensional Equality", () => {
        expect(composeFgGacb_1.composeFgGacb(utilities_1.fn1)(utilities_1.fn3)(utilities_1.a)(utilities_1.b)(utilities_1.c)).toStrictEqual([[utilities_1.a, utilities_1.c, utilities_1.b]]);
        expect(composeFgGacb_1.composeFgGacb(utilities_1.fn1)(utilities_1.fn3)(utilities_1.a)(utilities_1.c)(utilities_1.b)).toStrictEqual([[utilities_1.a, utilities_1.b, utilities_1.c]]);
        expect(composeFgGacb_1.composeFgGacb(utilities_1.fn1)(utilities_1.fn3)(utilities_1.b)(utilities_1.a)(utilities_1.c)).toStrictEqual([[utilities_1.b, utilities_1.c, utilities_1.a]]);
        expect(composeFgGacb_1.composeFgGacb(utilities_1.fn1)(utilities_1.fn3)(utilities_1.b)(utilities_1.c)(utilities_1.a)).toStrictEqual([[utilities_1.b, utilities_1.a, utilities_1.c]]);
        expect(composeFgGacb_1.composeFgGacb(utilities_1.fn1)(utilities_1.fn3)(utilities_1.c)(utilities_1.a)(utilities_1.b)).toStrictEqual([[utilities_1.c, utilities_1.b, utilities_1.a]]);
        expect(composeFgGacb_1.composeFgGacb(utilities_1.fn1)(utilities_1.fn3)(utilities_1.c)(utilities_1.b)(utilities_1.a)).toStrictEqual([[utilities_1.c, utilities_1.a, utilities_1.b]]);
    });
});
//# sourceMappingURL=composeFgGacb.spec.js.map