"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const composeFgGba_1 = require("../composeFgGba");
const utilities_1 = require("./utilities");
describe("Partial Application", () => {
    test("Arity", () => {
        expect(composeFgGba_1.composeFgGba.length).toStrictEqual(1);
        expect(composeFgGba_1.composeFgGba(utilities_1.fn1).length).toStrictEqual(1);
        expect(composeFgGba_1.composeFgGba(utilities_1.fn1)(utilities_1.fn2).length).toStrictEqual(1);
        expect(composeFgGba_1.composeFgGba(utilities_1.fn1)(utilities_1.fn2)(utilities_1.a).length).toStrictEqual(1);
        expect(composeFgGba_1.composeFgGba(utilities_1.fn1)(utilities_1.fn2)(utilities_1.a)(utilities_1.b).length).toStrictEqual(1);
    });
});
describe("Referential Transparency", () => {
    test("Extensional Equality", () => {
        expect(composeFgGba_1.composeFgGba(utilities_1.fn1)(utilities_1.fn2)(utilities_1.a)(utilities_1.b)).toStrictEqual([[utilities_1.b, utilities_1.a]]);
        expect(composeFgGba_1.composeFgGba(utilities_1.fn1)(utilities_1.fn2)(utilities_1.b)(utilities_1.a)).toStrictEqual([[utilities_1.a, utilities_1.b]]);
    });
});
//# sourceMappingURL=composeFgGba.spec.js.map