import {composeFgGba as compose} from "../composeFgGba";
import {a as a, b as b, fn1 as F, fn2 as G} from "./utilities";

describe("Partial Application", () => {

    test("Arity", () => {
        expect(compose.length).toStrictEqual(1);
        expect(compose(F).length).toStrictEqual(1);
        expect(compose(F)(G).length).toStrictEqual(1);
        expect(compose(F)(G)(a).length).toStrictEqual(1);
        expect(compose(F)(G)(a)(b).length).toStrictEqual(1);
    });

});

describe("Referential Transparency", () => {

    test("Extensional Equality", () => {
        expect(compose(F)(G)(a)(b)).toStrictEqual([[b, a]]);
        expect(compose(F)(G)(b)(a)).toStrictEqual([[a, b]]);
    });

});
